// --------------------------------------------------------
// Code generated by Papyrus C++
// --------------------------------------------------------

#ifndef BARECTF_CLASSES_BARECTFINIT_H
#define BARECTF_CLASSES_BARECTFINIT_H

/************************************************************
              BareCTFInit class header
 ************************************************************/

#include "barectf/classes/Pkg_classes.h"

#include "PrimitiveTypes/Pkg_PrimitiveTypes.h"
#include "ctf/barectf-platform-fs.h"
#include "map"
#include "mutex"
#include "sysinterfaces/ILifeCycle.h"

// Include from Include stereotype (header)
#include <stddef.h>	// for NULL
#include <sstream>
#include <map>
#include <thread>
#include <mutex>

// End of Include stereotype (header)


// derived using directives
using namespace PrimitiveTypes;
using namespace sysinterfaces;

namespace barectf {
namespace classes {

/************************************************************/
/**
 * 
 */
class BareCTFInit : 
public ILifeCycle
 {
	public:
	
	/**
	 * 
	 */
	static String metadataPath;
	
	/**
	 * 
	 */
	static std::map<std::thread::id,barectf_default_ctx*> ctx_map;
	
	/**
	 * 
	 */
	static std::mutex mtx;
	
	/**
	 * 
	 * @return ret 
	 */
	static  barectf_default_ctx* ctx();
	
	/**
	 * 
	 */
	void deactivate();
	
	/**
	 * 
	 */
	void activate();
	
	/**
	 * 
	 */
	void configuration_complete();


};
/************************************************************/
/* External declarations (package visibility)               */
/************************************************************/


/* Inline functions                                         */


} // of namespace classes
} // of namespace barectf

/************************************************************
              End of BareCTFInit class header
 ************************************************************/

#endif
